<template>
<v-container class="font">
    <v-row justify="space-between">
        <v-col cols="12" md="6">
            <v-card elevation="2">
                <v-card-title class="headline">
                    รถเข็น
                </v-card-title>
                <v-divider></v-divider>
                <v-card-text>
                    <v-list>
                        <v-list-item v-for="item in cartItems" :key="item.productId">
                            <v-list-item-content>
                                <div align="center" justify="center">
                                    <v-img v-if="item.picmenu" :src="item.picmenu" max-height="300" max-width="300" contain></v-img>
                                    <div v-else style="height: 300px; width: 300px; display: flex; align-items: center; justify-content: center; background-color: lightgray;">
                                        <span>Image not available</span>
                                    </div>
                                </div>
                                <v-list-item-title>{{ item.productName }}</v-list-item-title>
                                <v-list-item-subtitle>ราคา: {{ item.price }} บาท</v-list-item-subtitle>
                            </v-list-item-content>
                            <v-list-item-action>
                                <v-row align="center" justify="center" no-gutters>
                                    <v-col cols="auto">
                                        <v-btn @click="decreaseQuantity(item.productId)" outlined small icon>
                                            <v-icon>mdi-minus</v-icon>
                                        </v-btn>
                                    </v-col>
                                    <v-col cols="auto">
                                        <v-list-item-subtitle>{{ item.quantity }}</v-list-item-subtitle>
                                    </v-col>
                                    <v-col cols="auto">
                                        <v-btn @click="increaseQuantity(item.productId)" outlined small icon>
                                            <v-icon>mdi-plus</v-icon>
                                        </v-btn>
                                    </v-col>
                                </v-row>
                            </v-list-item-action>
                            <v-list-item-action>
                                <v-btn @click="removeItem(item.productId)" outlined small icon>
                                    <v-icon>mdi-delete</v-icon>
                                </v-btn>
                            </v-list-item-action>
                        </v-list-item>
                    </v-list>
                </v-card-text>
                <v-row>
                    <v-col class="text-start">

                        <v-icon elevation="2" @click="goHome()" fab>mdi-arrow-left</v-icon>
                        กลับไปยังหน้า Home
                    </v-col>
                </v-row>
            </v-card>
        </v-col>

        <v-col cols="12" md="6">
            <v-card elevation="2">
                <v-card-title class="headline">
                    รวม
                </v-card-title>
                <v-divider></v-divider>
                <v-card-text>
                    <v-row>
                        <v-col class="text-right">
                            <v-subheader>ราคา: {{ totalPrice }} บาท</v-subheader>
                        </v-col>
                    </v-row>
                </v-card-text>
                <v-divider></v-divider>
                <v-card-actions style="justify-content: center;" align="center">
                    <v-btn color="primary" @click="checkout()">
                        ชำระเงิน
                    </v-btn>
                </v-card-actions>
            </v-card>
            <div>
                <v-dialog v-model="toggle" max-width="500">
                    <v-card>
                        <v-card-title style="justify-content: center;">
                            QR Code ชำระเงิน
                        </v-card-title>
                        <div>
                            <v-img :src="`data:image/png;base64,${qrBase64}`"></v-img>
                            <div style="display: flex; justify-content: space-around; padding: 10px;">
                                <v-btn color="success" @click="paymentss()">
                                    ชำระเงินแล้ว
                                </v-btn>
                                <v-btn color="error" @click="paymentcc()">
                                    ยกเลิก
                                </v-btn>
                            </div>
                        </div>
                    </v-card>
                </v-dialog>
            </div>
        </v-col>
    </v-row>
</v-container>
</template>

<script>
import axios from 'axios';
import Swal from 'sweetalert2';
import Cookies from 'js-cookie';
import {
    jwtDecode
} from "jwt-decode";

export default {
    data() {
        return {
            token: Cookies.get('token'),
            cartItems: [],
            detail: [],
            qrBase64: "",
            toggle: false,
            orderid: "",
            loginId: ''
        };
    },
    mounted() {
        this.fetchCartItems();
        this.getuser();
    },
    computed: {
        totalPrice() {
            return this.cartItems.reduce((total, item) => {
                return total + (item.price || 0) * (item.quantity || 0);
            }, 0);
        },
    },
    methods: {
        async payment() {
            let product2 = [];
            this.cartItems.map((carts) => {
                product2.push({
                    product: carts.productId,
                    quantity: carts.quantity
                });
                console.log(carts.productId);
            });
            const payload = {
                products: product2
            };
            console.log(product2);
            console.log(payload);

            try {
                const response = await axios.post('http://192.168.73.121:3000/orders', payload);
                console.log(response.data.data.data.qrCode);
                this.qrBase64 = response.data.data.data.qrCode;
                console.log(response.data);

                const orderId = response.data.data.orderId;
                console.log(orderId);

                this.orderid = orderId;

            } catch (error) {
                console.error('There was an error making the request:', error);
            }
        },
        async fetchCartItems() {
            try {
                const response = await axios.get(`http://192.168.73.121:3000/cart/${this.loginId}`, {
                    headers: {
                        Authorization: `Bearer ${this.token}`
                    }
                });
                console.log(response.data);
                this.cartItems = response.data.products;
            } catch (error) {
                console.error('Error fetching cart items:', error);
            }
        },
        async increaseQuantity(productId) {
            try {
                const item = this.cartItems.find(item => item.productId === productId);
                if (item) {
                    const productResponse = await axios.get(`/products`);
                    const product = productResponse.data.data;

                    if (item.quantity < product.amount) {
                        item.quantity++;
                        await axios.post(`/carts/${this.loginId}/add`, {
                            productId,
                            quantity: 1
                        });
                    } else {
                        alert('Quantity exceeds available stock');
                    }
                }
            } catch (error) {
                console.error('Error increasing quantity:', error);
            }
        },
        async decreaseQuantity(productId) {
            try {
                const item = this.cartItems.find(item => item.productId === productId);
                if (item && item.quantity > 1) {
                    item.quantity--;
                    await axios.post(`/carts/${this.loginId}/add`, {
                        productId,
                        quantity: -1
                    });
                }
            } catch (error) {
                console.error('Error decreasing quantity:', error);
            }
        },
        async removeItem(productId) {
            try {
                this.cartItems = this.cartItems.filter(item => item.productId !== productId);
                await axios.delete(`/carts/${this.loginId}/remove/${productId}`);
            } catch (error) {
                console.error('Error removing item:', error);
            }
        },
        async checkout() {
            this.toggle = !this.toggle
            this.payment()
        },
        goHome() {
            this.$router.push('/homepage');
        },
        async paymentss() {
            const payload = {
                detail: {
                    merchant_id: "M00016978",
                    order_description: "",
                    order_id: this.orderid,
                    payment_acquirer_bank: "BBL",
                    payment_reference_id: "P2405291634473791345",
                    payment_type: "QR",
                    receive_amount: 1,
                    response_code: 201,
                    response_message: "Success",
                    transaction_date: "20240529",
                    transaction_time: "165646"
                },
                event: "payment_status_change",
                merchant_id: "M00016978",
                retry_flag: "N",
                timestamp: new Date().toISOString()
            };
            console.log(payload);

            const token = 'eyJhbGciOiJIUzI1NiIsInR5cCI6IkpXVCJ9.eyJfaWQiOiI2NjU1OTQxZGQzYjNlZGU5ZDk4OTFiNGUiLCJ1c2VybmFtZSI6IkthcmVuIiwicm9sZSI6WyJ1c2VyIl0sInN0YXR1cyI6IkFQUFJPVkUiLCJpYXQiOjE3MTcwNTAyOTQsImV4cCI6MTcxNzEzNjY5NH0.PoV32Ld_z3v7lCEukd0cINgsq0mZCKKzovzy0iJOr-k';
            const config = {
                headers: {
                    Authorization: `Bearer ${token}`
                },
            };
            try {
                const response = await axios.post('http://192.168.75.212:3000/orders/payment/confrim', payload, config);
                console.log(response.data);
                Swal.fire({
                    title: "ชำระเงินสำเร็จ",
                    text: "ได้รับออร์เดอร์ของคุณแล้ว",
                    icon: "success"
                });
            } catch (error) {
                console.error('There was an error making the request:', error);
            }
        },
        paymentcc() {
            location.reload();
        },
        async getuser() {
            if (this.token) {
                try {
                    const decoded = jwtDecode(this.token);
                    this.firstName = decoded.firstName;
                    this.loginId = decoded._id;
                    console.log(this.firstName);
                    console.log(this.loginId);
                } catch (error) {
                    Swal.fire({
                        position: "center",
                        icon: "error",
                        title: "Session Expired",
                        showConfirmButton: false,
                        timer: 3000
                    });
                    this.$router.push('/Homepage');
                }
            } else {
                Swal.fire({
                    position: "center",
                    icon: "error",
                    title: "Time Out",
                    showConfirmButton: false,
                    timer: 3000
                });
                this.$router.push('/Homepage');
            }
        },
    }
};
</script>

<style scoped>
@import url("https://fonts.googleapis.com/css2?family=Prompt:ital,wght@0,100;0,200;0,300;0,400;0,500;0,600;0,700;0,800;0,900;1,100;1,200;1,300;1,400;1,500;1,600;1,700;1,800;1,900&display=swap");

.font {
    font-family: "Prompt", sans-serif;
}

.headline {
    font-weight: bold;
    font-size: 24px;
}
</style>
